/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################





#include "server_stdafx.h"






#undef NET_DECLARE_ONLY			//NB!


#define WINSERVER_FOR_MULTIPLECLIENT_CPP




#include "tasand1/config.h"



#include "winServerForMultipleClient.h"
//#include <sstream>								    ///moved to server_stdafx.h
#include "debug_semaphore.h"



#define ALLOW_COUT 0


///#######################################################################
///
///#######################################################################





///#######################################################################
///
///#######################################################################


myLog winLog("server.log");


///########################################################################

#if 0
void print2(const std::string text)
{
	//interfaceToGui->print(text);
	
	//TODO
	
	cout << text;
};
#endif


mySemaphore *global_executeSemaphore;
extern bool exitflag;
extern int exit_progress;


mySemaphore *my_coutSemaphore;
myThreadArgument* serverArgument1;
myThreadArgument* serverArgument2;

std::list<myThreadArgument *> clientArgument;
std::list<myThread *> clientHandle;


mySemaphore *net_exist_Semaphore = NULL;
mySemaphore *step_completion_semaphore = NULL;
///extern mySemaphore *debug_semaphore;



myThread *serverThread = NULL;
myThread *debug_table_thread = NULL;
myThread *beeper_thread = NULL;
myThread *curr_clientHandle = NULL;


extern Controller_manager Controller_manager_obj;



extern long *_crtBreakAlloc_ptr;



///########################################################################

void server_uninit_main()
{
	
	
	
				  
	
	
	for (std::list<myThreadArgument *>::iterator i = clientArgument.begin(); i != clientArgument.end(); i ++)
	{
		myThreadArgument **arg = (myThreadArgument **)(&*i);
		
		myTcpSocket* client = (*arg)->getClientConnect();
		delete client;
		
		//if (arg->getExitEvent() != NULL)
			delete (*arg);	
	}
	

	for (std::list<myThread *>::iterator i = clientHandle.begin(); i != clientHandle.end(); i ++)
	{
		myThread **arg = (myThread **)(&*i);
		
		
		delete (*arg);		
	}
	
	
	clientArgument.clear();
	clientHandle.clear();
	
	
	
	
	delete my_coutSemaphore;
	delete global_executeSemaphore;
	delete serverArgument1;
	delete serverArgument2;
	
	delete net_exist_Semaphore;
	delete step_completion_semaphore;
	
	///delete debug_semaphore;
	
	
	if (debug_table_thread != NULL)
		delete debug_table_thread;


	if (beeper_thread != NULL)
		delete beeper_thread;

		
	//if (curr_clientHandle != NULL)
	//	delete curr_clientHandle;
	
	//clientHandle.begin();
	
	
		
	delete serverThread;
	
}

///########################################################################

void server_init_main()
{
	static bool inited = false;
	if (inited)
		return;
	inited = true;


	/// build a semaphore so we can synchronize the access to std cout
	/// also includes the log file
	


	controller_ptr = NULL;			//not started
	

	//cout.setparent(this);		

	//Controller_Server_interfaceToGui = Connection::guiControllerInterface;


	/// build a semaphore so we can synchronize the access to std cout
	/// also includes the log file
	//string voidname;
	//voidname = "";
	std::string name1 = std::string("coutSemaphore");
	std::string name2 = std::string("execSemaphore");
	my_coutSemaphore = new mySemaphore(name1, 1, 1, CREATE, TRUE);
	global_executeSemaphore = new mySemaphore(name2, 1, 1, CREATE, TRUE);    


	///debug_semaphore_init();


	/// Initialize the winsock library
	myTcpSocket::initialize();



#if 0

	/// create the server: local host will be used as the server, let us 
	/// first use myHostInfo class to show the name and IP address 
	/// of the local host
	winLog << endl;
	winLog << "Retrieve the local host name and address:" << endl;
	
	myHostInfo serverInfo;
	string serverName = serverInfo.getHostName();
	string serverIPAddress = serverInfo.getHostIPAddress();
	print2("my localhost (server) information:");
	print2("	Name:    " + serverName);
	print2("	Address: " + serverIPAddress);
	winLog << "		==> Name: " << serverName << endl;
	winLog << "		==> Address: " << serverIPAddress << endl;

	/// open socket on the local host(server) and show its configuration
	myTcpSocket myServer(PORTNUM);
	//print2(myServer);
	winLog << myServer;

	/// create a thread to implement server process: listening to the socket,
	/// accepting client calls and communicating with clients. This will free the 
	/// main control (see below) to do other process.
	myThreadArgument* serverArgument = new myThreadArgument(&myServer, my_coutSemaphore, serverName, my_execSemaphore, this);
	serverThread = new myThread(&Controller_Server::serverHandleThread, (void*)serverArgument);						///will wait for new connections
	serverThread->execute();


	myThread* housekeeperThread = new myThread(&Controller_Server::housekeeper, (void*)serverArgument);						///will wait for new connections
	housekeeperThread->execute();
#else

	/// create a thread to implement server process: listening to the socket,
	/// accepting client calls and communicating with clients. This will free the 
	/// main control (see below) to do other process.
	std::string name3;
	name3 = std::string("__main_thread");
	serverArgument1 = new myThreadArgument(NULL, my_coutSemaphore, global_executeSemaphore, &controller_ptr, name3);
	serverThread = new myThread(/*&Controller_Server::*/serverHandleThread, (void*)serverArgument1);						///will wait for new connections
	serverThread->execute();
	exit_progress++;

#endif												
}

///########################################################################

DWORD WINAPI /*Controller_Server::*/housekeeper(LPVOID threadInfo)					//TODO: exiting this loop thread
{
	using std::endl;
	using std::cout;
	
	
	
#if _DEBUG
	
	long *local_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*local_crtBreakAlloc_ptr = *_crtBreakAlloc_ptr;
	
	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(*_crtBreakAlloc_ptr);
	
#endif
	
	
	
	
	myThreadArgument *serverArgument = (myThreadArgument *)threadInfo;

	/// main control: since the serverThread is handling the server functions,
	/// this main control is free to do other things.
#pragma warning(disable : 4127)	
	while (!exitflag)				///will do housekeeping at 50sec intervals
#pragma warning(default : 4127)	
	
	{
		mySemaphore* coutSemaphore = serverArgument->getCoutSemaphore();
	
		/// do whatever you need to do here, I am using Sleep(x) 
		/// to make a little delay, pretending to be the other 
		/// possible processings.
		Sleep(10000);

		/// report the server status
		coutSemaphore->lock();
		std::string hostname = serverArgument->getHostName();
#if ALLOW_COUT		
		cout << endl << "-----------------------------------------------------------------" << endl;
		cout << /*serverName*/ hostname << ") status report:" << endl;
		cout << "   the following clients have successfully connected with server: " << endl;
#endif		
		winLog << endl << "-----------------------------------------------------------------" << endl;
		winLog << "server (name:" << /*serverName*/ hostname << ") status report:" << endl;
		winLog << "   the following clients have successfully connected with server: " << endl;
		
		
		size_t i;
		
		
		serverArgument->beginClientArgument();
		for (i = 0; i < /*MAX_NUM_CLIENTS*/serverArgument->size(); i ++)
		{
			myThreadArgument* clientInfo = serverArgument->getNextClientArgument();
			if ( clientInfo ) 
			{
#if ALLOW_COUT					
				cout << "         " << clientInfo->getHostName() << endl;
#endif				
				winLog << "         " << clientInfo->getHostName() << endl;
			}
		}
#if ALLOW_COUT		
		cout << "   the following clients have shutdown the connection: " << endl;
#endif
		winLog << "   the following clients have shutdown the connection: " << endl;
		
		
		
		serverArgument->beginClientArgument();
		for (i = 0; i < /*MAX_NUM_CLIENTS*/serverArgument->size(); i ++)
		{
			myThreadArgument* clientInfo = serverArgument->getNextClientArgument();
			if ( clientInfo && clientInfo->getExitEvent()->waitForEvent(0) )
			{
				clientInfo->setSignalToEnd(true);
#if ALLOW_COUT		
				cout << "         " << clientInfo->getHostName() << endl;
#endif
				winLog << "         " << clientInfo->getHostName() << endl;
			}
		}
#if ALLOW_COUT		
		cout << "-----------------------------------------------------------------" << endl << endl;
#endif
		winLog << "-----------------------------------------------------------------" << endl << endl;
		
		coutSemaphore->unlock();
	};	
	
	
	exit_progress--;
	return 1;
};		

//server thread that deals with opened connections to clients
DWORD WINAPI /*Controller_Server::*/clientHandleThread(LPVOID threadInfo)
{



	/// Initialize the winsock library
	myTcpSocket::initialize();		///seems like it must be done here once again





#if _DEBUG

	long *local_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*local_crtBreakAlloc_ptr = *_crtBreakAlloc_ptr;


	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(*_crtBreakAlloc_ptr);
	
#endif	
	


	/// this structure will contain all the data this callback will work on
    myThreadArgument* clientArgument_local = (myThreadArgument*)threadInfo;
		
	/// the semamphore to protect the access to the std output
    //mySemaphore* coutSemaphore = clientArgument->getCoutSemaphore();
    mySemaphore* executeSemaphore = clientArgument_local->getExecuteSemaphore();

	/// get the client connection: receiving messages from client and
	/// sending messages to the client will all be done by using
	/// this client connection
	myTcpSocket* clientConnection = clientArgument_local->getClientConnect();
	std::string clientName = clientArgument_local->getHostName();
	
	
	Controller_Server **controller_ptrptr = clientArgument_local->getController();
	

	/// the server is communicating with this client here
#pragma warning(disable : 4127)		
	while(!exitflag)
#pragma warning(default : 4127)		
	{
		//string messageFromClient = "";
		
		
		
		
		executeSemaphore->lock();
		
		if (*controller_ptrptr == NULL)				//lets start controller right now
		{
			Controller_manager::start_controller(); 
			_ASSERT(*controller_ptrptr != NULL);
#pragma warning (push)		
#pragma warning (disable : 6011)		   /// warning C6011: Dereferencing NULL pointer '*controller_ptrptr': 
			(*controller_ptrptr)->init(); 				
#pragma warning (pop)			
		}

		executeSemaphore->unlock();

		
		
		
		
		
		/// receive from the client

		REQUEST_STRUCT mess_in;
        int numBytes = clientConnection->recieveMessage(&mess_in);
		if ( numBytes == -99 ) /*break*/ goto endloop2;

		/// write to the console and the log file, so lock the semaphore
		//coutSemaphore->lock();

		//cout   << "[RECV fr " << clientName << "]: " << messageFromClient << endl;
		//winLog << "[RECV fr " << clientName << "]: " << messageFromClient << endl;




		if (!exitflag)			///could be set by close window event during receiveMessage
		{

			executeSemaphore->lock();

			if (*controller_ptrptr == NULL)				//whatever request enters, the controller must be started
			{
				Controller_manager::start_controller(); 
				(*controller_ptrptr)->init(); 				
			}





			(*controller_ptrptr)->set_clientConnection_modal(clientConnection);		

			
			
			bool reply_sent = false;

			switch (mess_in.header.cmd_id)
			{
				case SERVER_INIT:				//controller is already inited a dozen lines upwards with first call to the server//
					//(*controller_ptr)->init();													
					break;
				
				
				case SERVER_UNINIT:	
					SEND_ACK(DONE_TO_CLIENT, clientConnection);					
					//controller->uninit();
					delete (*controller_ptrptr);
					*controller_ptrptr = NULL;
					
					executeSemaphore->unlock();
					goto endloop;					//no need to drop connection, alhough client will drop it probably itself
					break;	    
					
				
				case SERVER_EXECUTE_STEP:
				case SERVER_ONKEYPRESSED:
					SEND_ACK(DONE_TO_CLIENT, clientConnection);				///first send ack then start exec with backwards-queries
					
					try
					{
						switch (mess_in.header.cmd_id)
						{
							case SERVER_EXECUTE_STEP:
								(*controller_ptrptr)->execute_1();
								break;
								
							case SERVER_ONKEYPRESSED:
								(*controller_ptrptr)->onKeyPressed_1(*mess_in.intdata);
								break;
								
							default:
								break;
						};
									
					}
					catch(myException& excp)
					{
						excp.response();
						//exit(1);
						
						if ((excp.getErrCode() == WSAECONNRESET) || (excp.getErrCode() == WSAECONNABORTED))
						{
							//clientArgument_local->setSignalToEnd(TRUE);
							//delete clientConnection;
							executeSemaphore->unlock();
							goto endloop;
						}
					}
					
					break;
					
				
				case SERVER_NOP:
				default:
					break;	
							
			};
			
			if (!reply_sent)
			{
				SEND_ACK(DONE_TO_CLIENT, clientConnection);	
			}

			executeSemaphore->unlock();

			

			//TODO: call execute or other function with parameter that refers to clientConnection, or use one global clientConnection in class


	#if 0
			/// if the client wants to discount
			if ( messageFromClient.compare("quit") == 0 || messageFromClient.compare("Quit") == 0 )
			{
				//coutSemaphore->unlock();
				break;
			}
			else /// send to the client
			{
				char messageToClient[MAX_MSG_LEN+1];
				memset(messageToClient, 0, sizeof(messageToClient));
				cout << "[SEND to " << clientName << "]: ";
				cin.getline(messageToClient, MAX_MSG_LEN);
				winLog << "[SEND to " << clientName << "]: " << messageToClient << endl;
				clientConnection->sendMessage(string(messageToClient));
				//coutSemaphore->unlock();
			}
	#endif
	
	
	
		}		///if (!exitflag)			///could be set by close window event during receiveMessage
		
    }


endloop:

	



	


endloop2:



	if (exitflag)
	{
		executeSemaphore->lock();
		
		if (*controller_ptrptr != NULL)
		{
			delete (*controller_ptrptr);
			*controller_ptrptr = NULL;
		}
		
		executeSemaphore->unlock();
	}



	/// if we reach here, this session with the client is done,
	/// so we set the event on this thread to inform the main
	/// control that this session is finished
	clientArgument_local->getExitEvent()->setEvent();
	exit_progress--;
	return 1;
	
}

///########################################################################

//server thread that accepts new connections
DWORD WINAPI /*Controller_Server::*/serverHandleThread(LPVOID threadInfo_init)							//TODO: exiting this loop thread
{
	using std::endl;
	using std::cout;
	
	


#if _DEBUG	
	
	long *local_crtBreakAlloc_ptr = &_crtBreakAlloc;
	*local_crtBreakAlloc_ptr = *_crtBreakAlloc_ptr;
	
	
	_CrtSetDbgFlag (_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(*_crtBreakAlloc_ptr);
	
#endif	
	
	
	
	
	
	
	
	/// this structure will contain all the data this callback will work on
    myThreadArgument* serverArgument_init = (myThreadArgument*)threadInfo_init;

	/// the semamphore to protect the access to the std output
    mySemaphore* coutSemaphore = serverArgument_init->getCoutSemaphore();
    mySemaphore* executeSemaphore = serverArgument_init->getExecuteSemaphore();
    Controller_Server **controller_ptrptr = serverArgument_init->getController();





	/// Initialize the winsock library
	myTcpSocket::initialize();
	
	
	

	/// create the server: local host will be used as the server, let us 
	/// first use myHostInfo class to show the name and IP address 
	/// of the local host
	winLog << endl;
	winLog << "Retrieve the local host name and address:" << endl;
	
	
	//__debugbreak();
	
#if 1	
	myHostInfo serverInfo;													///roland: causes error when running inside performance analyzer
#else
	std::string sName1("localhost");
	myHostInfo serverInfo(sName1, NAME);						
#endif	
	std::string serverName = serverInfo.getHostName();
	std::string serverIPAddress = serverInfo.getHostIPAddress();

	cout << "my localhost (server) information:" << endl;
	cout << "	Name:    " << serverName << endl;
	cout << "	Address: " << serverIPAddress << endl;
	winLog << "		==> Name: " << serverName << endl;
	winLog << "		==> Address: " << serverIPAddress << endl;

	/// open socket on the local host(server) and show its configuration
	myTcpSocket myServer(PORTNUM);
	//print2(myServer);
	cout << myServer;
	winLog << myServer;

	/// create a thread to implement server process: listening to the socket,
	/// accepting client calls and communicating with clients. This will free the 
	/// main control (see below) to do other process.
	serverArgument2 = new myThreadArgument(&myServer, coutSemaphore, executeSemaphore, controller_ptrptr, serverName);
	//myThread* serverThread = new myThread(&Controller_Server::serverHandleThread, (void*)serverArgument2);						///will wait for new connections
	//serverThread->execute();


	//myThread* housekeeperThread = new myThread(/*&Controller_Server::*/housekeeper, (void*)serverArgument);						///will wait for new connections
	//housekeeperThread->execute();
	//exit_progress++;






	/// this structure will contain all the data this callback will work on
    //myThreadArgument* serverArgument = (myThreadArgument*)threadInfo;
		

	/// get the server
	//myTcpSocket* myServer = serverArgument->getClientConnect();
	//string serverName = serverArgument->getHostName();

	/// bind the server to the socket
    myServer.bindSocket();
	cout << endl << "server finishes binding process... " << endl;
	winLog << endl << "server finishes binding process... " << endl;
	
	/// server starts to wait for client calls
	myServer.listenToClient();
	cout << "server is waiting for client calls ... " << endl;
	winLog << "server is waiting for client calls ... " << endl;
	
	/// server starts to listen, and generates a thread to 
	/// handle each client

	//myThreadArgument* clientArgument[MAX_NUM_CLIENTS];
	//std::list<myThreadArgument *> clientArgument;
	//myThread* clientHandle[MAX_NUM_CLIENTS];
	//std::list<myThread *> clientHandle;

#if 0
	for ( int i = 0; i < /*MAX_NUM_CLIENTS*/clientArgument.size(); i++ )
	{
		clientArgument[i] = NULL;
		clientHandle[i] = NULL;
#endif



	executeSemaphore->lock();

	if (*controller_ptrptr == NULL)				//lets start controller right now
	{
		Controller_manager::start_controller(); 
		_ASSERT(*controller_ptrptr != NULL);
#pragma warning (push)		
#pragma warning (disable : 6011)		   /// warning C6011: Dereferencing NULL pointer '*controller_ptrptr': 		
		(*controller_ptrptr)->init(); 				
#pragma warning (pop)		
	}

	executeSemaphore->unlock();



	
	int currNumOfClients = 0;
	
	
	myTcpSocket* client = NULL;
	

#pragma warning(disable : 4127)	
	while (!exitflag)
#pragma warning(default : 4127)		
	{
		/// wait to accept a client connection.  
		/// processing is suspended until the client connects
    	//myTcpSocket* client;    /// connection dedicated for client communication
		std::string clientName;      /// client name 
		client = myServer.acceptClient(clientName);	
		
		
		if (!exitflag)
		{
			if (client == NULL)		///unable to accept client, probably network config errors!
			{
				exitflag = true;
				
				
				coutSemaphore->lock();
	//#if ALLOW_COUT		
				cout << endl << endl << endl << "UNABLE TO ACCEPT CLIENT!" << endl << endl << "exiting..." << endl;
	//#endif        			
				//print2("\n\n\nUNABLE TO ACCEPT CLIENT!\n\nexiting...\n");
				coutSemaphore->unlock();
				
			}
			else
			{		
			
				//clientName = clientName + "-" + char(65+currNumOfClients);
				//clientName.printf("%s-%d", clientName, currNumOfClients);
				//clientName = clientName + "-" + itoa(currNumOfClients);
				std::ostringstream rval;
				rval << clientName << "-" << currNumOfClients;
				clientName = rval.str();

				/// lock the std out so we can write to the console
				coutSemaphore->lock();
	#if ALLOW_COUT		
				cout << endl << "==> A client from [" << clientName << "] is connected!" << endl << endl;
	#endif        
				winLog << endl << "==> A client from [" << clientName << "] is connected!" << endl << endl;
				coutSemaphore->unlock();

				/// for this client, generate a thread to handle it
				//if (currNumOfClients < (MAX_NUM_CLIENTS - 1))
				//{
					clientArgument.push_back(new myThreadArgument(client, coutSemaphore, executeSemaphore, controller_ptrptr, clientName));
					//list<myThreadArgument *>::iterator curr_clientArgument = clientArgument.back();
					myThreadArgument *curr_clientArgument = clientArgument.back();

					
					
					//if (curr_clientHandle != NULL)
					//	delete curr_clientHandle;
					
					
					clientHandle.push_back(new myThread(/*&Controller_Server::*/clientHandleThread, /*(void*)clientArgument[currNumOfClients])*/(void *)curr_clientArgument) );
					//list<myThread *>::iterator curr_clientHandle = 
					curr_clientHandle = clientHandle.back();
					
					
					//clientArgument[currNumOfClients] = new myThreadArgument(client, coutSemaphore, executeSemaphore, controller_ptr, clientName);
					//clientHandle[currNumOfClients] = new myThread(/*&Controller_Server::*/clientHandleThread, (void*)clientArgument[currNumOfClients]);
					serverArgument2->addClientArgument(/*clientArgument[currNumOfClients]*/ (myThreadArgument *)curr_clientArgument);
					//clientHandle[currNumOfClients]->execute();
					((myThread *)curr_clientHandle)->execute();
					exit_progress++;
					
					currNumOfClients++;
					
					
					client = NULL;		
				//}
			}
		
		
			//delete client;		///free socket object
		
		
		}   ///if (client == NULL)		///unable to accept client, probably network config errors!
	}


	if (client != NULL)				///when server receives exit signal, myTcpSocket manages to create one more/new connection but after that exitflag will be set for this loop here too
		delete client;


	//exit_progress--;
    return 1;
}

///########################################################################

