/*  ***** BEGIN LICENSE BLOCK *****
 *  Version: RPPL 1.0/GPL 2.0/LGPL 2.1/MPL 1.1/CDDL 1.0
 *  
 *  
 *  The contents of this file are subject to the Roland Pihlakas Public
 *  License Version 1.0 (the "License"); you may not use this file except
 *  in compliance with the License. You may obtain a copy of the License
 *  at http://roland.pri.ee/RPPL/
 *  
 *  Software distributed under the License is distributed on an "AS IS"
 *  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 *  License for the specific language governing rights and limitations
 *  under the License.
 *  
 *  The Original Code is: Modelling of Natural Thinking.
 *  
 *  The Initial Developer of the Original Code is: Roland Pihlakas.
 *  
 *  Portions created by: _____________________________ 
 *  are Copyright (C): _____________________________. 
 *  All Rights Reserved.
 *  Contributor(s): ______________________________________.
 *  
 *  Alternatively, the contents of this file may be used under the terms of 
 *  either the GNU General Public License Version 2 or later (the "GPL"), or 
 *  the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), or 
 *  the Mozilla Public Licence Version 1.1 or later (the "MPL"), or the Common 
 *  Development and Distribution License Version 1.0 or later (the "CDDL"), in 
 *  which case the provisions of the MPL, the GPL, the LGPL or the CDDL are 
 *  applicable instead of those above. If you wish to allow use of your version 
 *  of this file only under the terms of the of either the MPL, the GPL, 
 *  the LGPL or the CDDL, and not to allow others to use your version of this 
 *  file under the RPPL, indicate your decision by deleting the provisions 
 *  above and replace them with the notice and other provisions required by 
 *  the MPL, the GPL, the LGPL or the CDDL. If you do not delete the provisions 
 *  above, a recipient may use your version of this file under the terms of any 
 *  one of the RPPL, the MPL, the GPL, the LGPL or the CDDL.
 *
 *  ***** END LICENSE BLOCK ***** */

//######################################################################################################
//
//######################################################################################################




#define SIMPLE_OPERANT		1
#define INTERVAL_SCHEDULE	2
#define RATIO_SCHEDULE		3
#define INSIGHT				4
#define ACTION_DURATION		5			///the code on controllers side is probably obsolete, inconsistent



#define TEST_SELECT			4




///########################################################################
///
///########################################################################




A get_planned_vals_energy__ln_base					= 0;		//50;
S sa_linear_cycles_budget_per_param					= 25;
A sa_good_enough_energy								= 0;




A insightful_net__activate_all_output_classes_above_abs_val			= 0.25f;




#if TEST_SELECT == SIMPLE_OPERANT

	#define USE_DISCRIMINANT_NET						1
	#define ACTION_STRENGTH_MEANS_ACTION_DURATION		1
	
	#define TEST_LINEFOLLOWER							0
	#define TEST_INTERVAL_SCHEDULE						0					///NB!
	#define TEST_RATIO_SCHEDULE							0					///NB!
	#define TEST_INSIGHT								0					///NB!
	A reinforcement_interval							= 0.9f;
	
	#define EMPTY_ECHOLINES_ON_LOAD						(1 || TEST_LINEFOLLOWER)
	
	
	
	float duration_one_timesteps_quota				= 300;
	//namespace ai { __declspec(selectany) float activate_all_classes_above_abs_val	= 0.25f; }
	
	
																	   
	///cant use const bool here, because these vars are exported
	
	bool ENABLE_DUAL_MEMORY_SYSTEM						= true;			///if USE_BLOCKING and !USE_SLOWED_EXTINCTION then uses shortterm memory learning speed formula
	A memory_select_dynamics_speed						= 0.5f;
	A learning_speed_for_blocking_shortterm_mem			= 0.8f;
	A learning_speed_for_longterm_mem					= 0.8f;
	
	A insightful_net__activate_all_input_classes_above_abs_val	= FLT_MAX;		///NB!
	
	bool USE_BLOCKING									= true;	//true;
	bool USE_SLOWED_EXTINCTION							= true;
	bool DISABLE_INPUT_CLASSIFIER_LEARNING				= true;	//false;

	bool INCREASE_FUTURELINE_WEIGHT						= true;

	bool EXTEND_IMAGINED_ACTION_THROUGH_ECHOLINE		= false;	//true;
	bool EXTEND_IMAGINED_DISCRIMINANT_THROUGH_ECHOLINE	= true;
	bool COMBINE_ACTIONS_WITH_DISCRIMINANTS_ECHOES		= true;

	bool ENABLE_INSIGHT									= false;			///NB!
	bool SA_USE_OUTPUT_VAL_DIRECTIONS					= true;
	int INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY			= 2;
	
	bool BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE		= true;
	bool ENABLE_UPDATE_CORRS_DURING_MANUAL_CONTROL		= true;
	bool ENABLE_UPDATE_CORRS_DURING_INCOMPLETE_ACTION	= false;
	
	float minimal_energy_for_action						= 0.1f;
	A use_action_duration								= 0 ? 0.0f : 0.28f;
	A inc_action_duration_sent_to_net_by				= 0;	//(use_action_duration == 0) ? 0 : 0.25f;
	S pause_after_every_action							= 0 ? 0 : 15;
	A initial_operant_actual_value						= 0.0f;				///NB!
	A reinforcement_size								= 1;				///NB!
	
	S simulated_annealing_runs_per_workcycle			= BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE ? 4 : 1;
	A sa_lowerbound_g									= -0.25f;		    ///NB!
	A sa_upperbound_g									= 1.25f;
	

	
	
	A sa_action_debug_points							= (use_action_duration == 0) ? 0.9 : use_action_duration;
	A sa_debug_input_val1								= 0.50f;								  ///NB!
	A sa_debug_input_val2								= reinforcement_interval;	//1.00f;	  ///NB!
	

	
	
	float MAX_INPUTS_E_RATIO							= 2.0f;			 ///used when INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY = 1, for extrapolation in futureline
	
	
	
	size_t NUM_OUTPUTS									= 2;	
	
	const size_t delay_input_data_timesteps				= 0;	//	///necessary in order to learn discriminant stimuli in cases when reinforcement follows action start right away. This way net learns the context where decision was made, not the context where action was started
	const size_t delay_output_data_timesteps			= 0;	//0;
	const size_t delay_operant_data_timesteps			= 0;	//4;
	
#endif	///#if TEST_SELECT == INERVAL_SCHEDULE
	


///########################################################################
///
///########################################################################



#if TEST_SELECT == INTERVAL_SCHEDULE

	#define USE_DISCRIMINANT_NET						1
	#define ACTION_STRENGTH_MEANS_ACTION_DURATION		1
	
	#define TEST_LINEFOLLOWER							0
	#define TEST_INTERVAL_SCHEDULE						1					///NB!
	#define TEST_RATIO_SCHEDULE							0					///NB!
	#define TEST_INSIGHT								0					///NB!
	A reinforcement_interval							= 0.9f;
	
	#define EMPTY_ECHOLINES_ON_LOAD						(1 || TEST_LINEFOLLOWER)
	
	
	
	float duration_one_timesteps_quota				= 300;
	//namespace ai { __declspec(selectany) float activate_all_classes_above_abs_val	= 0.25f; }
	
	
																	   
	///cant use const bool here, because these vars are exported
	
	bool ENABLE_DUAL_MEMORY_SYSTEM						= true;			///if USE_BLOCKING and !USE_SLOWED_EXTINCTION then uses shortterm memory learning speed formula
	A memory_select_dynamics_speed						= 0.5f;
	A learning_speed_for_blocking_shortterm_mem			= 0.8f;
	A learning_speed_for_longterm_mem					= 0.8f;
	
	A insightful_net__activate_all_input_classes_above_abs_val	= 0.0f;		///NB!
	
	bool USE_BLOCKING									= true;	//true;
	bool USE_SLOWED_EXTINCTION							= true;
	bool DISABLE_INPUT_CLASSIFIER_LEARNING				= true;	//false;

	bool INCREASE_FUTURELINE_WEIGHT						= true;

	bool EXTEND_IMAGINED_ACTION_THROUGH_ECHOLINE		= false;	//true;
	bool EXTEND_IMAGINED_DISCRIMINANT_THROUGH_ECHOLINE	= true;
	bool COMBINE_ACTIONS_WITH_DISCRIMINANTS_ECHOES		= true;

	bool ENABLE_INSIGHT									= false;			///NB!
	bool SA_USE_OUTPUT_VAL_DIRECTIONS					= true;
	int INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY			= 2;
	
	bool BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE		= true;
	bool ENABLE_UPDATE_CORRS_DURING_MANUAL_CONTROL		= true;
	bool ENABLE_UPDATE_CORRS_DURING_INCOMPLETE_ACTION	= false;
	
	float minimal_energy_for_action						= 0.003f;
	A use_action_duration								= 0 ? 0.0f : 0.28f;
	A inc_action_duration_sent_to_net_by				= 0;	//(use_action_duration == 0) ? 0 : 0.25f;
	S pause_after_every_action							= 0 ? 0 : 15;
	A initial_operant_actual_value						= TEST_INTERVAL_SCHEDULE ? -1.0f : 0.0f;	 ///NB!
	A reinforcement_size								= TEST_INTERVAL_SCHEDULE ? 0.01 : 1;		 ///NB!
	
	S simulated_annealing_runs_per_workcycle			= BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE ? 4 : 1;
	A sa_lowerbound_g									= -0.25f;		    ///NB!
	A sa_upperbound_g									= 1.25f;
	

	
	
	A sa_action_debug_points							= (use_action_duration == 0) ? 0.9 : use_action_duration;
	A sa_debug_input_val1								= 0.50f;								  ///NB!
	A sa_debug_input_val2								= reinforcement_interval;	//1.00f;	  ///NB!
	

	
	
	float MAX_INPUTS_E_RATIO							= 2.0f;			 ///used when INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY = 1, for extrapolation in futureline
	
	
	
	size_t NUM_OUTPUTS									= 1;	
	
	const size_t delay_input_data_timesteps				= 0;	//	///necessary in order to learn discriminant stimuli in cases when reinforcement follows action start right away. This way net learns the context where decision was made, not the context where action was started
	const size_t delay_output_data_timesteps			= 0;	//0;
	const size_t delay_operant_data_timesteps			= 0;	//4;
	
#endif	///#if TEST_SELECT == INERVAL_SCHEDULE
	


///########################################################################
///
///########################################################################



#if TEST_SELECT == RATIO_SCHEDULE

	#define USE_DISCRIMINANT_NET						1
	#define ACTION_STRENGTH_MEANS_ACTION_DURATION		1
	
	#define TEST_LINEFOLLOWER							0
	#define TEST_INTERVAL_SCHEDULE						0					///NB!
	#define TEST_RATIO_SCHEDULE							1					///NB!
	#define TEST_INSIGHT								0					///NB!
	//A reinforcement_interval							= 0.9f;
	
	
	#define EMPTY_ECHOLINES_ON_LOAD						(1 || TEST_LINEFOLLOWER)
	S reinforcement_ratio								= 4;
	
	
	float duration_one_timesteps_quota				= 300;
	//namespace ai { __declspec(selectany) float activate_all_classes_above_abs_val	= 0.25f; }
	
	
																	   
	///cant use const bool here, because these vars are exported
	
	bool ENABLE_DUAL_MEMORY_SYSTEM						= true;			///if USE_BLOCKING and !USE_SLOWED_EXTINCTION then uses shortterm memory learning speed formula
	A memory_select_dynamics_speed						= 0.5f;
	A learning_speed_for_blocking_shortterm_mem			= 0.8f;
	A learning_speed_for_longterm_mem					= 0.8f;
	
	A insightful_net__activate_all_input_classes_above_abs_val	= FLT_MAX;		///NB!
	
	bool USE_BLOCKING									= true;	//true;
	bool USE_SLOWED_EXTINCTION							= true;
	bool DISABLE_INPUT_CLASSIFIER_LEARNING				= true;	//false;

	bool INCREASE_FUTURELINE_WEIGHT						= true;

	bool EXTEND_IMAGINED_ACTION_THROUGH_ECHOLINE		= false;	//true;
	bool EXTEND_IMAGINED_DISCRIMINANT_THROUGH_ECHOLINE	= true;
	bool COMBINE_ACTIONS_WITH_DISCRIMINANTS_ECHOES		= true;

	bool ENABLE_INSIGHT									= true;				///NB!
	bool SA_USE_OUTPUT_VAL_DIRECTIONS					= true;
	int INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY			= 2;
	
	bool BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE		= true;
	bool ENABLE_UPDATE_CORRS_DURING_MANUAL_CONTROL		= true;
	bool ENABLE_UPDATE_CORRS_DURING_INCOMPLETE_ACTION	= false;
	
	float minimal_energy_for_action						= 0.003f;
	A use_action_duration								= 0 ? 0.0f : 0.28f;
	A inc_action_duration_sent_to_net_by				= 0;	//(use_action_duration == 0) ? 0 : 0.25f;
	S pause_after_every_action							= 0 ? 0 : 15;
	A initial_operant_actual_value						= TEST_RATIO_SCHEDULE ? -1.0f : 0.0f;	  ///NB!
	A reinforcement_size								= TEST_RATIO_SCHEDULE ? 0.01 : 1;		  ///NB!
	
	S simulated_annealing_runs_per_workcycle			= BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE ? 4 : 1;
	A sa_lowerbound_g									= -0.25f;			///NB!
	A sa_upperbound_g									= 1.25f;
	

	
	
	A sa_action_debug_points							= (use_action_duration == 0) ? 0.9 : use_action_duration;
	A sa_debug_input_val1								= 0.0f;				///NB!
	A sa_debug_input_val2								= 1.00f;			///NB!
	

	
	
	float MAX_INPUTS_E_RATIO							= 2.0f;			 ///used when INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY = 1, for extrapolation in futureline
	
	
	
	size_t NUM_OUTPUTS									= 1;				///NB!
	
	const size_t delay_input_data_timesteps				= 0;	//	///necessary in order to learn discriminant stimuli in cases when reinforcement follows action start right away. This way net learns the context where decision was made, not the context where action was started
	const size_t delay_output_data_timesteps			= 0;	//0;
	const size_t delay_operant_data_timesteps			= 0;	//4;
	
#endif	///#if TEST_SELECT == INERVAL_SCHEDULE
	
	
	
///########################################################################
///
///########################################################################



#if TEST_SELECT == INSIGHT

	#define USE_DISCRIMINANT_NET						1
	#define ACTION_STRENGTH_MEANS_ACTION_DURATION		1
	
	#define TEST_LINEFOLLOWER							0
	#define TEST_INTERVAL_SCHEDULE						0					///NB!
	#define TEST_RATIO_SCHEDULE							0					///NB!
	#define TEST_INSIGHT								1					///NB!
	//A reinforcement_interval							= 0.9f;
	
	#define EMPTY_ECHOLINES_ON_LOAD						(1 || TEST_LINEFOLLOWER)
	
	
	
	float duration_one_timesteps_quota					= 300;
	//namespace ai { __declspec(selectany) float activate_all_classes_above_abs_val	= 0.25f; }
	
	
																	   
	///cant use const bool here, because these vars are exported
	
	bool ENABLE_DUAL_MEMORY_SYSTEM						= true;			///if USE_BLOCKING and !USE_SLOWED_EXTINCTION then uses shortterm memory learning speed formula
	A memory_select_dynamics_speed						= 0.5f;
	A learning_speed_for_blocking_shortterm_mem			= 0.8f;
	A learning_speed_for_longterm_mem					= 0.8f;
	
	A insightful_net__activate_all_input_classes_above_abs_val	= FLT_MAX;		///NB!
	
	bool USE_BLOCKING									= true;	//true;
	bool USE_SLOWED_EXTINCTION							= true;
	bool DISABLE_INPUT_CLASSIFIER_LEARNING				= true;	//false;

	bool INCREASE_FUTURELINE_WEIGHT						= true;

	bool EXTEND_IMAGINED_ACTION_THROUGH_ECHOLINE		= false;	//true;
	bool EXTEND_IMAGINED_DISCRIMINANT_THROUGH_ECHOLINE	= true;
	bool COMBINE_ACTIONS_WITH_DISCRIMINANTS_ECHOES		= true;

	bool ENABLE_INSIGHT									= true;				///NB!
	bool SA_USE_OUTPUT_VAL_DIRECTIONS					= true;
	int INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY			= 2;
	
	bool BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE		= true;
	bool ENABLE_UPDATE_CORRS_DURING_MANUAL_CONTROL		= true;
	bool ENABLE_UPDATE_CORRS_DURING_INCOMPLETE_ACTION	= false;
	
	float minimal_energy_for_action						= 0.01f;
	A use_action_duration								= 0 ? 0.0f : 0.28f;
	A inc_action_duration_sent_to_net_by				= 0;	//(use_action_duration == 0) ? 0 : 0.25f;
	S pause_after_every_action							= 0 ? 0 : 15;
	A initial_operant_actual_value						= -1.0f;				///NB!
	A reinforcement_size								= 0.01f;				///NB!
	
	S simulated_annealing_runs_per_workcycle			= BLOCK_PLANNING_UNTIL_ACTION_IS_COMPLETE ? 4 : 1;
	A sa_lowerbound_g									= -0.25f;			///NB!
	A sa_upperbound_g									= 1.25f;
	

	
	
	A sa_action_debug_points							= (use_action_duration == 0) ? 0.9 : use_action_duration;
	A sa_debug_input_val1								= 0.0f;				///NB!
	A sa_debug_input_val2								= 1.00f;			///NB!
	

	
	
	float MAX_INPUTS_E_RATIO							= 2.0f;			 ///used when INSIGHT_USES_INPUT_VAL_DIRECTIONS_ONLY = 1, for extrapolation in futureline
	
	
	
	size_t NUM_OUTPUTS									= 2;				///NB!
	
	const size_t delay_input_data_timesteps				= 0;	//	///necessary in order to learn discriminant stimuli in cases when reinforcement follows action start right away. This way net learns the context where decision was made, not the context where action was started
	const size_t delay_output_data_timesteps			= 0;	//0;
	const size_t delay_operant_data_timesteps			= 0;	//4;
	
#endif	///#if TEST_SELECT == INERVAL_SCHEDULE
	
	

///########################################################################
///
///########################################################################
